#ifndef AtlasProd_ddl
#define AtlasProd_ddl

#include "atlasSchema.h"
#include "HepODBMS/tagdb/HepEvent.h"
#include "HepODBMS/tagdb/HepEventTag.h"
#include "HepODBMS/odbms/HepVArray.h"

class AtlasProdParticle {
public :
  d_Short istat;
  d_Short ipdg;
  d_Short imo1;
  d_Short imo2;
  d_Short idau;
  d_Float px;
  d_Float py;
  d_Float pz;
  d_Float mass;
  d_Float tof;
  d_Float vx;
  d_Float vy;
  d_Float vz;
  AtlasProdParticle() {}
};

declare (HepVArray,AtlasProdParticle)

class AtlasProdCalo {
public :
  d_UShort N_total;
  d_Float E_total;
  AtlasProdCalo() {}
};

class AtlasProdEvent : public HepEvent {
public :
  d_Float  time;
  d_UShort NpGenz; 
  d_UShort NgTrack; 
  d_UShort NgVertx; 
  d_UShort NgSTMAX; 
  d_UShort Nsetdet; 
  d_Long   NgTMult;
  d_Long   Nwords;
  d_Long   Nwfree;
  d_Long   NPIXHPBCR;
  d_Long   LPIXHPBCR;
  d_Long   NPIXHPECR;
  d_Long   LPIXHPECR;
  d_Long   NSCTHSCTB;
  d_Long   LSCTHSCTB;
  d_Long   NZSCHZSEN;
  d_Long   LZSCHZSEN;
  d_Long   NXTRHXGAS;
  d_Long   LXTRHXGAS;
  d_Long   NCOIHCOEA;
  d_Long   LCOIHCOEA;
  d_Long   NCRYHCBEA;
  d_Long   LCRYHCBEA;
  d_Long   NCRYHCEEA;
  d_Long   LCRYHCEEA;
  d_Long   NCRYHCEPS;
  d_Long   LCRYHCEPS;
  d_Long   NCRYHCRAC;
  d_Long   LCRYHCRAC;
  d_Long   NCRYHCREC;
  d_Long   LCRYHCREC;
  d_Long   NACCHSTAC;
  d_Long   LACCHSTAC;
  d_Long   NCOPHCPCE;
  d_Long   LCOPHCPCE;
  d_Long   NENDHENDC;
  d_Long   LENDHENDC;
  d_Long   NTILHTBSA;
  d_Long   LTILHTBSA;
  d_Long   NHENHHLAR;
  d_Long   LHENHHLAR;
  d_Long   NFWDHFWAI;
  d_Long   LFWDHFWAI;
  d_Long   NPIXDPBCR;
  d_Long   LPIXDPBCR;
  d_Long   NPIXDPECR;
  d_Long   LPIXDPECR;
  d_Long   NSCTDSCTB;
  d_Long   LSCTDSCTB;
  d_Long   NZSCDZSEN;
  d_Long   LZSCDZSEN;
  d_Long   NXTRDXGAS;
  d_Long   LXTRDXGAS;
  d_Long   NCRYDCBEA;
  d_Long   LCRYDCBEA;
  d_Long   NCRYDCEEA;
  d_Long   LCRYDCEEA;
  d_Long   NCRYDCRAC;
  d_Long   LCRYDCRAC;
  d_Long   NCRYDCREC;
  d_Long   LCRYDCREC;
  d_Long   NCRYDCEPS;
  d_Long   LCRYDCEPS;
  d_Long   NACCDSTAC;
  d_Long   LACCDSTAC;
  d_Long   NCOPDCOPH;
  d_Long   LCOPDCOPH;
  d_Long   NENDDENDC;
  d_Long   LENDDENDC;
  d_Long   NTILDTBMA;
  d_Long   LTILDTBMA;
  d_Long   NHENDHENN;
  d_Long   LHENDHENN;
  d_Long   NFWDDFWSI;
  d_Long   LFWDDFWSI;
  d_Long   Nsum;
  AtlasProdCalo calos[3];
  HepVArray (AtlasProdParticle) particles;
  HepHintDeclare;
public:
  AtlasProdEvent () {};
};

class AtlasProdTag : public HepEventTag {
public:
  d_Long idrun ;
  d_Long idevnt ;
  d_Long itrflag ;
  d_Long ISUB ;
  d_Long  Nhard ;
  d_Short Npart ;
  d_Float vvx ;
  d_Float vvy ;
  d_Float vvz ;

  static  int  checkDescr();
  HepRef(AtlasProdEvent) getEvent() {return (HepRef(AtlasProdEvent)&)event();}

  HepHintDeclare;
};

#endif /* AtlasProd_ddl */




