/* C++ header file: Objectivity/DB DDL version 4.0.2 */

#ifndef _ATLAS_PROD_H
#define _ATLAS_PROD_H

#ifdef OO_DDL_TRANSLATION
#pragma ooddlout "AtlasProd.ddl"
class opiDummyDeclaration;
#endif

#ifndef OO_H
#include <oo.h>
#endif
#include "atlasSchema.h"
#include "HepODBMS/tagdb/HepEvent.h"
#include "HepODBMS/tagdb/HepEventTag.h"
#include "HepODBMS/odbms/HepVArray.h"
#line 2 "AtlasProd.ddl"
#define AtlasProd_ddl 

#ifndef _ATLAS_PROD_REF_H
#include "AtlasProd_ref.h"
#endif

#line 9 "AtlasProd.ddl"
class AtlasProdParticle { 

public: int16 istat; 
int16 ipdg; 
int16 imo1; 
int16 imo2; 
int16 idau; 
float32 px; 
float32 py; 
float32 pz; 
float32 mass; 
float32 tof; 
float32 vx; 
float32 vy; 
float32 vz; 
inline AtlasProdParticle() { }
}; 

declare(ooVArray,AtlasProdParticle)class AtlasProdParticle_HepVArray : public ooVArray(AtlasProdParticle) { public: inline size_t length() const { return size (); }inline size_t entries() const { return size (); }inline AtlasProdParticle &operator()(const uint32 index) const { return operator [ ] (index); }
#line 27
inline AtlasProdParticle &last() { return operator [ ] (size () - 1); }inline void doofInline() { }inline ooStatus insert(const AtlasProdParticle &newElem) { return extend (newElem); }inline ooStatus append(const AtlasProdParticle &newElem) { return extend (newElem); }inline int isEmpty() const { return size () == 0; }
#line 27
inline void clear() { resize (0); }inline void reshape(size_t newsz) { resize (newsz); }}; 

class AtlasProdCalo { 

public: uint16 N_total; 
float32 E_total; 
inline AtlasProdCalo() { }
}; 

class AtlasProdEvent : public HepEvent { 

public: float32 time; 
uint16 NpGenz; 
uint16 NgTrack; 
uint16 NgVertx; 
uint16 NgSTMAX; 
uint16 Nsetdet; 
int32 NgTMult; 
int32 Nwords; 
int32 Nwfree; 
int32 NPIXHPBCR; 
int32 LPIXHPBCR; 
int32 NPIXHPECR; 
int32 LPIXHPECR; 
int32 NSCTHSCTB; 
int32 LSCTHSCTB; 
int32 NZSCHZSEN; 
int32 LZSCHZSEN; 
int32 NXTRHXGAS; 
int32 LXTRHXGAS; 
int32 NCOIHCOEA; 
int32 LCOIHCOEA; 
int32 NCRYHCBEA; 
int32 LCRYHCBEA; 
int32 NCRYHCEEA; 
int32 LCRYHCEEA; 
int32 NCRYHCEPS; 
int32 LCRYHCEPS; 
int32 NCRYHCRAC; 
int32 LCRYHCRAC; 
int32 NCRYHCREC; 
int32 LCRYHCREC; 
int32 NACCHSTAC; 
int32 LACCHSTAC; 
int32 NCOPHCPCE; 
int32 LCOPHCPCE; 
int32 NENDHENDC; 
int32 LENDHENDC; 
int32 NTILHTBSA; 
int32 LTILHTBSA; 
int32 NHENHHLAR; 
int32 LHENHHLAR; 
int32 NFWDHFWAI; 
int32 LFWDHFWAI; 
int32 NPIXDPBCR; 
int32 LPIXDPBCR; 
int32 NPIXDPECR; 
int32 LPIXDPECR; 
int32 NSCTDSCTB; 
int32 LSCTDSCTB; 
int32 NZSCDZSEN; 
int32 LZSCDZSEN; 
int32 NXTRDXGAS; 
int32 LXTRDXGAS; 
int32 NCRYDCBEA; 
int32 LCRYDCBEA; 
int32 NCRYDCEEA; 
int32 LCRYDCEEA; 
int32 NCRYDCRAC; 
int32 LCRYDCRAC; 
int32 NCRYDCREC; 
int32 LCRYDCREC; 
int32 NCRYDCEPS; 
int32 LCRYDCEPS; 
int32 NACCDSTAC; 
int32 LACCDSTAC; 
int32 NCOPDCOPH; 
int32 LCOPDCOPH; 
int32 NENDDENDC; 
int32 LENDDENDC; 
int32 NTILDTBMA; 
int32 LTILDTBMA; 
int32 NHENDHENN; 
int32 LHENDHENN; 
int32 NFWDDFWSI; 
int32 LFWDDFWSI; 
int32 Nsum; 
AtlasProdCalo calos[3]; 
AtlasProdParticle_HepVArray particles; 
static class HepClusteringHint clustering; 

inline AtlasProdEvent() { }
    virtual ooTypeNumber ooGetTypeN() const;
    virtual char* ooGetTypeName() const;
    ooBoolean ooIsKindOf(ooTypeNumber typeN) const;
    ooHandle(AtlasProdEvent)& ooThis(ooHandle(AtlasProdEvent)& objH,
			 ooMode aMode = oocNoOpen) const
      {
	opiGetObjHandle(ooDysoc(), objH, aMode);
	return objH;
      }
    ooHandle(AtlasProdEvent) ooThis(ooMode aMode = oocNoOpen) const;
    void *operator new(size_t, const ooHandle(ooObj) &nearH = oovTopDB);
    void *operator new(size_t, const ooId& nearId);
    void *operator new(size_t, ooConstCPtr(ooObj) nearObj);
    void *operator new(size_t,
		       const ooHandle(ooObj) &nearH,
		       const char *typeName);
#ifdef OO_ODMG
    void *operator new(size_t  size,
		       d_Database *odmg_db)
      {
	return opiODMGDatabaseNew(size, ooTypeN(AtlasProdEvent), odmg_db);
      }	
    void *operator new(size_t  size,
		       d_Database *odmg_db,
		       const char *)
      {
	return opiODMGDatabaseNew(size, ooTypeN(AtlasProdEvent), odmg_db);
      }	
#endif
    static const ooTypeNumber opiTypeN;
    static void ooAssocRegister();
    ooRef(AtlasProdEvent)& ooThis(ooRef(AtlasProdEvent)& objId, ooMode aMode = oocNoOpen) const;
    AtlasProdEvent(ooInternalObj iobj);
#line 119 "AtlasProd.ddl"
}; 

class AtlasProdTag : public HepEventTag { 

public: int32 idrun; 
int32 idevnt; 
int32 itrflag; 
int32 ISUB; 
int32 Nhard; 
int16 Npart; 
float32 vvx; 
float32 vvy; 
float32 vvz; 

static int checkDescr(); 
inline ooHandle(AtlasProdEvent) getEvent() { return (ooHandle(AtlasProdEvent) &) event (); }

static HepClusteringHint clustering; 
    virtual ooTypeNumber ooGetTypeN() const;
    virtual char* ooGetTypeName() const;
    ooBoolean ooIsKindOf(ooTypeNumber typeN) const;
    ooHandle(AtlasProdTag)& ooThis(ooHandle(AtlasProdTag)& objH,
			 ooMode aMode = oocNoOpen) const
      {
	opiGetObjHandle(ooDysoc(), objH, aMode);
	return objH;
      }
    ooHandle(AtlasProdTag) ooThis(ooMode aMode = oocNoOpen) const;
    void *operator new(size_t, const ooHandle(ooObj) &nearH = oovTopDB);
    void *operator new(size_t, const ooId& nearId);
    void *operator new(size_t, ooConstCPtr(ooObj) nearObj);
    void *operator new(size_t,
		       const ooHandle(ooObj) &nearH,
		       const char *typeName);
#ifdef OO_ODMG
    void *operator new(size_t  size,
		       d_Database *odmg_db)
      {
	return opiODMGDatabaseNew(size, ooTypeN(AtlasProdTag), odmg_db);
      }	
    void *operator new(size_t  size,
		       d_Database *odmg_db,
		       const char *)
      {
	return opiODMGDatabaseNew(size, ooTypeN(AtlasProdTag), odmg_db);
      }	
#endif
    static const ooTypeNumber opiTypeN;
    static void ooAssocRegister();
    ooRef(AtlasProdTag)& ooThis(ooRef(AtlasProdTag)& objId, ooMode aMode = oocNoOpen) const;
    AtlasProdTag(ooInternalObj iobj);
    AtlasProdTag() {}
#line 137 "AtlasProd.ddl"
}; 

#endif /* !defined(_ATLAS_PROD_H) */
