/* C++ 'references' header file: Objectivity/DB DDL version 4.0.2 */


#ifndef _ATLAS_PROD_REF_H
#define _ATLAS_PROD_REF_H

#ifndef OO_H
#include <oo.h>
#endif
#include "HepODBMS/tagdb/HepEvent_ref.h"
#include "HepODBMS/tagdb/HepEventTag_ref.h"
#if defined(_MSC_VER) && !defined(OO_DDL_TRANSLATION)
#pragma pack(push,8)
#endif
class AtlasProdEvent;
typedef AtlasProdEvent *AtlasProdEvent_ooCPtr;
typedef const AtlasProdEvent *AtlasProdEvent_const_ooCPtr;
typedef AtlasProdEvent &AtlasProdEvent_ooCRef;
typedef const AtlasProdEvent &AtlasProdEvent_const_ooCRef;


/////////////////////////////////////////////////////////////////////////////

#ifndef OO_BUGGY_TEMPLATES
class ooRef(AtlasProdEvent);
class ooShortRef(AtlasProdEvent);
class ooHandle(AtlasProdEvent);
#endif // !defined(OO_BUGGY_TEMPLATES)


class ooDeref(AtlasProdEvent) : public ooDerefBase {
  public:
    ~ooDerefStructor(AtlasProdEvent)();
    inline ooCPtr(AtlasProdEvent) operator->() const;
#ifndef OO_BUGGY_TEMPLATES
  private:
    friend ooRef(AtlasProdEvent);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooDerefStructor(AtlasProdEvent)(ooDeref(AtlasProdEvent)& deref);
    ooDerefStructor(AtlasProdEvent)(ooCPtr(ooObj) pObject);
};


#ifdef OO_BUGGY_TEMPLATES

class ooHandle_superclass<AtlasProdEvent > : public ooHandle(HepEvent) {
 protected:
  ooHandle_superclass()
    {}
  ooHandle_superclass(const ooRef(HepEvent)& id) :
      ooHandle(HepEvent)(id)
    {}
  ~ooHandle_superclass()
    {}
};

class ooShortRef_superclass<AtlasProdEvent > : public ooShortRef(HepEvent) {
};

#endif // OO_BUGGY_TEMPLATES


class ooRef(AtlasProdEvent) : public ooRef(HepEvent) {
  public:
    ooRefStructor(AtlasProdEvent)()
      {}
    ooRefStructor(AtlasProdEvent)(const ooRef(AtlasProdEvent)& id) :
	  ooRef(HepEvent)(id)
      {}
#ifdef OO_BUGGY_TEMPLATES
    ooRefStructor(AtlasProdEvent)(const ooHandle_superclass<AtlasProdEvent > &objH);
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooRefStructor(AtlasProdEvent)(const ooHandle(AtlasProdEvent)& objH);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooRefStructor(AtlasProdEvent)(ooConstCPtr(AtlasProdEvent) pObject);
    ooRef(AtlasProdEvent)& operator=(const ooRef(AtlasProdEvent)& id);
#ifdef OO_BUGGY_TEMPLATES
    ooRef(AtlasProdEvent)& operator=(const ooShortRef_superclass<AtlasProdEvent > &shortId);
    ooRef(AtlasProdEvent)& operator=(const ooHandle_superclass<AtlasProdEvent > &objH);
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooRef(AtlasProdEvent)& operator=(const ooShortRef(AtlasProdEvent) &shortId);
    ooRef(AtlasProdEvent)& operator=(const ooHandle(AtlasProdEvent)& objH);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooRef(AtlasProdEvent)& operator=(ooConstCPtr(AtlasProdEvent) pObject);
    ooStatus lookupObj(const ooHandle(ooObj)& scopeH,
		       const ooKey& key,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const ooKey& key,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const ooHandle(ooObj)& scopeH,
		       const char* name,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const char* name,
		       ooMode openMode = oocRead);
#ifndef OO_BUGGY_TEMPLATES
    ooRef(AtlasProdEvent)& copy(const ooHandle(ooObj)& nearH, ooRef(AtlasProdEvent)& newObjId) const;
    ooHandle(AtlasProdEvent)& copy(const ooHandle(ooObj)& nearH,
			ooHandle(AtlasProdEvent)& newObjH) const;
    ooHandle(AtlasProdEvent) copy(const ooHandle(ooObj)& nearH) const;
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooCPtr(AtlasProdEvent) pin(ooMode openMode = oocRead) const;
#if !defined(__DECCXX) || !defined(OO_VMS)
    ooDeref(AtlasProdEvent) operator->() const;
#endif
    /* Use pin() or use ooHandle operator ooCPtr(AtlasProdEvent) instead of vm. */
    /* OBSOLETE */ ooCPtr(AtlasProdEvent) vm(ooMode openMode = oocRead) const;
    // ODMG methods:
    ooRefStructor(AtlasProdEvent)(const d_Ref_Any &from);
    operator d_Ref_Any() const;
    AtlasProdEvent *ptr() const;
};


class ooShortRef(AtlasProdEvent) :
#ifdef OO_BUGGY_TEMPLATES
			public ooShortRef_superclass<AtlasProdEvent >
#else  // !defined(OO_BUGGY_TEMPLATES)
			public ooShortRef(HepEvent) 
#endif  // !defined(OO_BUGGY_TEMPLATES)
					            {
  public:
    ooShortRefStructor(AtlasProdEvent)();
    ooShortRefStructor(AtlasProdEvent)(const ooShortRef(AtlasProdEvent)& shortId);
    ooShortRefStructor(AtlasProdEvent)(const ooRef(AtlasProdEvent)& id);
#ifdef OO_BUGGY_TEMPLATES
    ooShortRefStructor(AtlasProdEvent)(const ooHandle_superclass<AtlasProdEvent > &objH);
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooShortRefStructor(AtlasProdEvent)(const ooHandle(AtlasProdEvent) &objH);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooShortRefStructor(AtlasProdEvent)(ooConstCPtr(AtlasProdEvent) pObject);
    ooShortRef(AtlasProdEvent)& operator=(const ooShortRef(AtlasProdEvent)& shortId);
    ooShortRef(AtlasProdEvent)& operator=(const ooRef(AtlasProdEvent)& id);
#ifdef OO_BUGGY_TEMPLATES
    ooShortRef(AtlasProdEvent)& operator=(const ooHandle_superclass<AtlasProdEvent > &objH);
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooShortRef(AtlasProdEvent)& operator=(const ooHandle(AtlasProdEvent)& objH);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooShortRef(AtlasProdEvent)& operator=(ooConstCPtr(AtlasProdEvent) pObject);
};


class ooHandle(AtlasProdEvent) :
#ifdef OO_BUGGY_TEMPLATES
		      public ooHandle_superclass<AtlasProdEvent >
#else  // !defined(OO_BUGGY_TEMPLATES)
		      public ooHandle(HepEvent)
#endif  // !defined(OO_BUGGY_TEMPLATES)
                                                {
  public:
    inline ooHandleStructor(AtlasProdEvent)();
    inline ooHandleStructor(AtlasProdEvent)(const ooRef(AtlasProdEvent)& id);
    inline ooHandleStructor(AtlasProdEvent)(const ooHandle(AtlasProdEvent)& objH);
    ooHandleStructor(AtlasProdEvent)(ooConstCPtr(AtlasProdEvent) pObject);
    ooHandle(AtlasProdEvent)& operator=(const ooRef(AtlasProdEvent)& id);
    ooHandle(AtlasProdEvent)& operator=(const ooHandle(AtlasProdEvent)& objH);
    ooHandle(AtlasProdEvent)& operator=(const ooShortRef(AtlasProdEvent)& shortId);
    ooHandle(AtlasProdEvent)& operator=(ooConstCPtr(AtlasProdEvent) pObject);
    ooStatus lookupObj(const ooHandle(ooObj)& scopeH,
		       const ooKey& key,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const ooKey& key,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const ooHandle(ooObj)& scopeH,
		       const char* name,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const char* name,
		       ooMode openMode = oocRead);
    ooHandle(AtlasProdEvent)& copy(const ooHandle(ooObj)& nearH,
			ooHandle(AtlasProdEvent)& newObjH) const;
    ooRef(AtlasProdEvent)& copy(const ooHandle(ooObj)& nearH,
		     ooRef(AtlasProdEvent)& newObjH) const;
    ooHandle(AtlasProdEvent) copy(const ooHandle(ooObj)& nearH) const;
    ooCPtr(AtlasProdEvent) pin(ooMode openMode = oocRead) const;
    ooCPtr(AtlasProdEvent) operator->() const;
    ooCRef(AtlasProdEvent) operator*() const;
    operator ooCPtr(AtlasProdEvent)() const;
    /* Use operator ooCPtr(AtlasProdEvent)() instead of vm. */
    /* OBSOLETE */ ooCPtr(AtlasProdEvent) vm() const;
    // ODMG methods:
    ooHandleStructor(AtlasProdEvent)(const d_Ref_Any &from);
    operator d_Ref_Any() const;
    AtlasProdEvent *ptr() const;
};

class ooItr(AtlasProdEvent) : public ooHandle(AtlasProdEvent) {
  public:
    ooItrStructor(AtlasProdEvent)();
    ~ooItrStructor(AtlasProdEvent)();
    ooStatus scan(const ooHandle(ooObj)& objH, ooMode mode = oocNoOpen);
    ooStatus scan(const ooHandle(ooObj)& objH, const char* predicate);
    ooStatus scan(const ooHandle(ooObj)& objH,
		  ooMode mode,
		  const ooAccessMode access,
		  const char* predicate);
    ooStatus scan(const ooHandle(ooObj)& objH,
		  const ooLookupKey& lookupKey,
		  ooMode mode = oocNoOpen);
    ooTypeNumber typeN() const;
    ooStatus	 end();
    ooBoolean	 next();
    ooIterator&	 get_itr();
  private:
    ooIterator	 _itr;
    ooItrStructor(AtlasProdEvent)(ooItr(AtlasProdEvent)&)
      {}
    void operator=(ooItr(AtlasProdEvent)&)
      {}
};


/* methods on ooDeref(AtlasProdEvent) */
inline
ooDeref(AtlasProdEvent)::ooDerefStructor(AtlasProdEvent)(ooDeref(AtlasProdEvent)& deref)
{
  set_vm(deref.vm());
  pin();
}
inline
ooDeref(AtlasProdEvent)::ooDerefStructor(AtlasProdEvent)(ooCPtr(ooObj) pObject)
{
  set_vm(pObject);
}
inline
ooDeref(AtlasProdEvent)::~ooDerefStructor(AtlasProdEvent)()
{
  unpin();
}
inline
ooCPtr(AtlasProdEvent)
ooDeref(AtlasProdEvent)::operator->() const
{
  return  (ooCPtr(AtlasProdEvent))vm();
}


/* methods on ooRef(AtlasProdEvent) */
inline
#ifdef OO_BUGGY_TEMPLATES
ooRef(AtlasProdEvent)::ooRefStructor(AtlasProdEvent)(const ooHandle_superclass<AtlasProdEvent > &objH)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooRef(AtlasProdEvent)::ooRefStructor(AtlasProdEvent)(const ooHandle(AtlasProdEvent)& objH)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  opiCtIdByHandle(*this, objH);
}
inline
ooRef(AtlasProdEvent)::ooRefStructor(AtlasProdEvent)(ooConstCPtr(AtlasProdEvent) pObject)
{
  opiCtIdByPtr(*this, pObject);
}
inline
ooRef(AtlasProdEvent)&
ooRef(AtlasProdEvent)::operator=(const ooRef(AtlasProdEvent)& id)
{
  ooId::operator=(id);
  return *this;
}
inline
ooRef(AtlasProdEvent)&
#ifdef OO_BUGGY_TEMPLATES
ooRef(AtlasProdEvent)::operator=(const ooShortRef_superclass<AtlasProdEvent > &shortId)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooRef(AtlasProdEvent)::operator=(const ooShortRef(AtlasProdEvent)& shortId)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  ooId::operator=(shortId);
  return *this;
}
inline
ooRef(AtlasProdEvent)&
#ifdef OO_BUGGY_TEMPLATES
ooRef(AtlasProdEvent)::operator=(const ooHandle_superclass<AtlasProdEvent > &objH)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooRef(AtlasProdEvent)::operator=(const ooHandle(AtlasProdEvent)& objH)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  opiCtIdByHandle(*this, objH);
  return *this;
}
inline
ooRef(AtlasProdEvent)&
ooRef(AtlasProdEvent)::operator=(ooConstCPtr(AtlasProdEvent) pObject)
{
  opiAsIdByPtr(*this, pObject);
  return *this;
}
inline
ooStatus
ooRef(AtlasProdEvent)::lookupObj(const ooKey& key, ooMode openMode)
{
  return lookupObj(oovTopDB, key, openMode);
}
inline
ooStatus
ooRef(AtlasProdEvent)::lookupObj(const char* name, ooMode openMode)
{
  return lookupObj(oovTopDB, name, openMode);
}
inline
ooCPtr(AtlasProdEvent)
ooRef(AtlasProdEvent)::vm(ooMode openMode) const
{
  ooId tempId(*this);
  return (ooCPtr(AtlasProdEvent)) opiOidVM(&tempId, openMode);
}
inline
ooCPtr(AtlasProdEvent)
ooRef(AtlasProdEvent)::pin(ooMode openMode) const
{
  ooId tempId(*this);
  return (ooCPtr(AtlasProdEvent)) opiOidVM(&tempId, openMode);
}
#ifndef OO_BUGGY_TEMPLATES
inline
ooHandle(AtlasProdEvent)&
ooRef(AtlasProdEvent)::copy(const ooHandle(ooObj)& nearH,
		 ooHandle(AtlasProdEvent)& newObjH) const
{
  ooHandle(AtlasProdEvent) thisH(*this);
      opiCopyObj(&thisH, nearH, newObjH);
  return newObjH;
}
inline
ooRef(AtlasProdEvent)&
ooRef(AtlasProdEvent)::copy(const ooHandle(ooObj)& nearH,
		 ooRef(AtlasProdEvent)& newObjId) const
{
  ooHandle(AtlasProdEvent) thisH(*this);
  ooHandle(AtlasProdEvent) newObjH;
  opiCopyObj(&thisH, nearH, newObjH);
  newObjId = newObjH;
  return newObjId;
}
inline
ooHandle(AtlasProdEvent)
ooRef(AtlasProdEvent)::copy(const ooHandle(ooObj)& nearH) const
{
  ooHandle(AtlasProdEvent) thisH(*this);
  ooHandle(AtlasProdEvent) newObjH;
  opiCopyObj(&thisH, nearH, newObjH);
  return newObjH;
}
#endif  // !defined(OO_BUGGY_TEMPLATES)
#if !defined(__DECCXX) || !defined(OO_VMS)
inline
ooDeref(AtlasProdEvent)
ooRef(AtlasProdEvent)::operator->() const
{
  ooId tempId(*this);
  ooDeref(AtlasProdEvent) deref(opiOidVM(&tempId, oocRead));
  return deref;
}
#endif


/* methods on ooShortRef(AtlasProdEvent) */
inline
ooShortRef(AtlasProdEvent)::ooShortRefStructor(AtlasProdEvent)()
{
}
inline
ooShortRef(AtlasProdEvent)::ooShortRefStructor(AtlasProdEvent)(const ooShortRef(AtlasProdEvent)& shortId)
{
  ooShortId::operator=(shortId);
}
inline
ooShortRef(AtlasProdEvent)::ooShortRefStructor(AtlasProdEvent)(const ooRef(AtlasProdEvent)& id)
{
  ooShortId::operator=(id);
}
inline
#ifdef OO_BUGGY_TEMPLATES
ooShortRef(AtlasProdEvent)::ooShortRefStructor(AtlasProdEvent)(const ooHandle_superclass<AtlasProdEvent > &objH)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooShortRef(AtlasProdEvent)::ooShortRefStructor(AtlasProdEvent)(const ooHandle(AtlasProdEvent)& objH)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  opiCtShortIdByHandle(*this, objH);
}
inline
ooShortRef(AtlasProdEvent)::ooShortRefStructor(AtlasProdEvent)(ooConstCPtr(AtlasProdEvent) pObject)
{
  opiCtShortIdByPtr(*this, pObject);
}
inline
ooShortRef(AtlasProdEvent)&
ooShortRef(AtlasProdEvent)::operator=(const ooShortRef(AtlasProdEvent)& shortId)
{
  ooShortId::operator=(shortId);
  return *this;
}
inline
ooShortRef(AtlasProdEvent)&
ooShortRef(AtlasProdEvent)::operator=(const ooRef(AtlasProdEvent)& id)
{
  ooShortId::operator=(id);
  return *this;
}
inline
ooShortRef(AtlasProdEvent)&
#ifdef OO_BUGGY_TEMPLATES
ooShortRef(AtlasProdEvent)::operator=(const ooHandle_superclass<AtlasProdEvent > &objH)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooShortRef(AtlasProdEvent)::operator=(const ooHandle(AtlasProdEvent)& objH)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  opiCtShortIdByHandle(*this, objH);
  return *this;
}
inline
ooShortRef(AtlasProdEvent)&
ooShortRef(AtlasProdEvent)::operator=(ooConstCPtr(AtlasProdEvent) pObject)
{
  opiAsShortIdByPtr(*this, pObject);
  return *this;
}


/* methods on ooHandle(AtlasProdEvent) */
inline
ooHandle(AtlasProdEvent)::ooHandleStructor(AtlasProdEvent)()
{
}
inline
ooHandle(AtlasProdEvent)::ooHandleStructor(AtlasProdEvent)(const ooHandle(AtlasProdEvent)& objH)
{
  opiCtHandleByHandle(*this, objH);
}
inline
ooHandle(AtlasProdEvent)::ooHandleStructor(AtlasProdEvent)(const ooRef(AtlasProdEvent)& id) :
#ifdef OO_BUGGY_TEMPLATES
    ooHandle_superclass<AtlasProdEvent >(id)
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooHandle(HepEvent)(id)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
}
inline
ooHandle(AtlasProdEvent)::ooHandleStructor(AtlasProdEvent)(ooConstCPtr(AtlasProdEvent) pObject)
{
  opiCtHandleByPtr(*this, pObject);
}
inline
ooHandle(AtlasProdEvent)&
ooHandle(AtlasProdEvent)::operator=(const ooHandle(AtlasProdEvent)& objH)
{
  opiAsHandleByHandle(*this, objH);
return *this;
}
inline
ooHandle(AtlasProdEvent)&
ooHandle(AtlasProdEvent)::operator=(const ooRef(AtlasProdEvent)& id)
{
  opiAsHandleById(*this, id);
  return *this;
}
inline
ooHandle(AtlasProdEvent)&
ooHandle(AtlasProdEvent)::operator=(const ooShortRef(AtlasProdEvent)& shortId)
{
  opiAsHandleByShortId(*this, shortId);
  return *this;
}
inline
ooHandle(AtlasProdEvent)&
ooHandle(AtlasProdEvent)::operator=(ooConstCPtr(AtlasProdEvent) pObject)
{
  (pObject) ? opiAsHandleByPtr(*this, pObject) : nullify();
  return *this;
}
inline
ooStatus
ooHandle(AtlasProdEvent)::lookupObj(const ooKey& key, ooMode openMode)
{
  return lookupObj(oovTopDB, key, openMode);
}
inline
ooStatus
ooHandle(AtlasProdEvent)::lookupObj(const char* name, ooMode openMode)
{
  return lookupObj(oovTopDB, name, openMode);
}
inline
ooCPtr(AtlasProdEvent)
ooHandle(AtlasProdEvent)::vm() const
{
  return (ooCPtr(AtlasProdEvent))get_vm();
}
inline
ooCRef(AtlasProdEvent)
ooHandle(AtlasProdEvent)::operator*() const
{
  return *vm();
}
inline
ooCPtr(AtlasProdEvent)
ooHandle(AtlasProdEvent)::pin(ooMode openMode) const
{
  opiOpenObj(this, openMode);
  opiPinDeref(get_fast_vm());
  return (ooCPtr(AtlasProdEvent))get_fast_vm();
}
inline
ooCPtr(AtlasProdEvent)
ooHandle(AtlasProdEvent)::operator->() const
{
  return (ooCPtr(AtlasProdEvent))get_vm();
}
inline
ooHandle(AtlasProdEvent)::operator ooCPtr(AtlasProdEvent)() const
{
  return (ooCPtr(AtlasProdEvent))get_vm();
}
inline
ooRef(AtlasProdEvent)&
ooHandle(AtlasProdEvent)::copy(const ooHandle(ooObj)& nearH, ooRef(AtlasProdEvent)& newObjId) const
{
  ooHandle(AtlasProdEvent) newObjH;
  opiCopyObj(this, nearH, newObjH);
  newObjId = newObjH;
  return newObjId;
}


/* methods on ooItr(AtlasProdEvent) */
inline
ooStatus
ooItr(AtlasProdEvent)::scan(const ooHandle(ooObj)& objH, ooMode mode)
{
  return opiInitScanItr(*this, objH, mode);
}
inline
ooStatus
ooItr(AtlasProdEvent)::scan(const ooHandle(ooObj)& objH,
		 const ooLookupKey& lookupKey,
		 ooMode mode)
{
  return opiInitScanIndexItr(*this, objH, lookupKey, mode);
}
inline
ooTypeNumber
ooItr(AtlasProdEvent)::typeN() const
{
  return opiGetItrTypeN(this);
}
inline
ooStatus
ooItr(AtlasProdEvent)::end()
{
  return opiCloseItr(*this);
}
inline
ooBoolean
ooItr(AtlasProdEvent)::next()
{
  return _itr.next(self());
}
inline
ooIterator&
ooItr(AtlasProdEvent)::get_itr()
{
  return _itr;
}
inline
ooStatus
ooItr(AtlasProdEvent)::scan(const ooHandle(ooObj)& objH,
		const char* predicate)
{
  return opiInitScanVPredItr(*this, objH, predicate, oocPublic, oocNoOpen);
}
inline
ooStatus
ooItr(AtlasProdEvent)::scan(const ooHandle(ooObj)& objH,
		 ooMode mode,
		 const ooAccessMode access,
		 const char* predicate)
{
  return opiInitScanVPredItr(*this, objH, predicate, access, mode);
}

/* ODMG methods */
inline
ooRef(AtlasProdEvent)::operator d_Ref_Any() const
{
  return (*((d_Ref_Any *) (this)));
}
inline
AtlasProdEvent *
ooRef(AtlasProdEvent)::ptr() const
{
  return this->pin();
}
inline
ooHandle(AtlasProdEvent)::operator d_Ref_Any() const
{
  ooRef(AtlasProdEvent) result = *this;
  return (*((const d_Ref_Any *) (&result)));
}
inline
AtlasProdEvent *
ooHandle(AtlasProdEvent)::ptr() const
{
  return this->operator->();
}
class AtlasProdTag;
typedef AtlasProdTag *AtlasProdTag_ooCPtr;
typedef const AtlasProdTag *AtlasProdTag_const_ooCPtr;
typedef AtlasProdTag &AtlasProdTag_ooCRef;
typedef const AtlasProdTag &AtlasProdTag_const_ooCRef;


/////////////////////////////////////////////////////////////////////////////

#ifndef OO_BUGGY_TEMPLATES
class ooRef(AtlasProdTag);
class ooShortRef(AtlasProdTag);
class ooHandle(AtlasProdTag);
#endif // !defined(OO_BUGGY_TEMPLATES)


class ooDeref(AtlasProdTag) : public ooDerefBase {
  public:
    ~ooDerefStructor(AtlasProdTag)();
    inline ooCPtr(AtlasProdTag) operator->() const;
#ifndef OO_BUGGY_TEMPLATES
  private:
    friend ooRef(AtlasProdTag);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooDerefStructor(AtlasProdTag)(ooDeref(AtlasProdTag)& deref);
    ooDerefStructor(AtlasProdTag)(ooCPtr(ooObj) pObject);
};


#ifdef OO_BUGGY_TEMPLATES

class ooHandle_superclass<AtlasProdTag > : public ooHandle(HepEventTag) {
 protected:
  ooHandle_superclass()
    {}
  ooHandle_superclass(const ooRef(HepEventTag)& id) :
      ooHandle(HepEventTag)(id)
    {}
  ~ooHandle_superclass()
    {}
};

class ooShortRef_superclass<AtlasProdTag > : public ooShortRef(HepEventTag) {
};

#endif // OO_BUGGY_TEMPLATES


class ooRef(AtlasProdTag) : public ooRef(HepEventTag) {
  public:
    ooRefStructor(AtlasProdTag)()
      {}
    ooRefStructor(AtlasProdTag)(const ooRef(AtlasProdTag)& id) :
	  ooRef(HepEventTag)(id)
      {}
#ifdef OO_BUGGY_TEMPLATES
    ooRefStructor(AtlasProdTag)(const ooHandle_superclass<AtlasProdTag > &objH);
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooRefStructor(AtlasProdTag)(const ooHandle(AtlasProdTag)& objH);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooRefStructor(AtlasProdTag)(ooConstCPtr(AtlasProdTag) pObject);
    ooRef(AtlasProdTag)& operator=(const ooRef(AtlasProdTag)& id);
#ifdef OO_BUGGY_TEMPLATES
    ooRef(AtlasProdTag)& operator=(const ooShortRef_superclass<AtlasProdTag > &shortId);
    ooRef(AtlasProdTag)& operator=(const ooHandle_superclass<AtlasProdTag > &objH);
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooRef(AtlasProdTag)& operator=(const ooShortRef(AtlasProdTag) &shortId);
    ooRef(AtlasProdTag)& operator=(const ooHandle(AtlasProdTag)& objH);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooRef(AtlasProdTag)& operator=(ooConstCPtr(AtlasProdTag) pObject);
    ooStatus lookupObj(const ooHandle(ooObj)& scopeH,
		       const ooKey& key,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const ooKey& key,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const ooHandle(ooObj)& scopeH,
		       const char* name,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const char* name,
		       ooMode openMode = oocRead);
#ifndef OO_BUGGY_TEMPLATES
    ooRef(AtlasProdTag)& copy(const ooHandle(ooObj)& nearH, ooRef(AtlasProdTag)& newObjId) const;
    ooHandle(AtlasProdTag)& copy(const ooHandle(ooObj)& nearH,
			ooHandle(AtlasProdTag)& newObjH) const;
    ooHandle(AtlasProdTag) copy(const ooHandle(ooObj)& nearH) const;
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooCPtr(AtlasProdTag) pin(ooMode openMode = oocRead) const;
#if !defined(__DECCXX) || !defined(OO_VMS)
    ooDeref(AtlasProdTag) operator->() const;
#endif
    /* Use pin() or use ooHandle operator ooCPtr(AtlasProdTag) instead of vm. */
    /* OBSOLETE */ ooCPtr(AtlasProdTag) vm(ooMode openMode = oocRead) const;
    // ODMG methods:
    ooRefStructor(AtlasProdTag)(const d_Ref_Any &from);
    operator d_Ref_Any() const;
    AtlasProdTag *ptr() const;
};


class ooShortRef(AtlasProdTag) :
#ifdef OO_BUGGY_TEMPLATES
			public ooShortRef_superclass<AtlasProdTag >
#else  // !defined(OO_BUGGY_TEMPLATES)
			public ooShortRef(HepEventTag) 
#endif  // !defined(OO_BUGGY_TEMPLATES)
					            {
  public:
    ooShortRefStructor(AtlasProdTag)();
    ooShortRefStructor(AtlasProdTag)(const ooShortRef(AtlasProdTag)& shortId);
    ooShortRefStructor(AtlasProdTag)(const ooRef(AtlasProdTag)& id);
#ifdef OO_BUGGY_TEMPLATES
    ooShortRefStructor(AtlasProdTag)(const ooHandle_superclass<AtlasProdTag > &objH);
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooShortRefStructor(AtlasProdTag)(const ooHandle(AtlasProdTag) &objH);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooShortRefStructor(AtlasProdTag)(ooConstCPtr(AtlasProdTag) pObject);
    ooShortRef(AtlasProdTag)& operator=(const ooShortRef(AtlasProdTag)& shortId);
    ooShortRef(AtlasProdTag)& operator=(const ooRef(AtlasProdTag)& id);
#ifdef OO_BUGGY_TEMPLATES
    ooShortRef(AtlasProdTag)& operator=(const ooHandle_superclass<AtlasProdTag > &objH);
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooShortRef(AtlasProdTag)& operator=(const ooHandle(AtlasProdTag)& objH);
#endif  // !defined(OO_BUGGY_TEMPLATES)
    ooShortRef(AtlasProdTag)& operator=(ooConstCPtr(AtlasProdTag) pObject);
};


class ooHandle(AtlasProdTag) :
#ifdef OO_BUGGY_TEMPLATES
		      public ooHandle_superclass<AtlasProdTag >
#else  // !defined(OO_BUGGY_TEMPLATES)
		      public ooHandle(HepEventTag)
#endif  // !defined(OO_BUGGY_TEMPLATES)
                                                {
  public:
    inline ooHandleStructor(AtlasProdTag)();
    inline ooHandleStructor(AtlasProdTag)(const ooRef(AtlasProdTag)& id);
    inline ooHandleStructor(AtlasProdTag)(const ooHandle(AtlasProdTag)& objH);
    ooHandleStructor(AtlasProdTag)(ooConstCPtr(AtlasProdTag) pObject);
    ooHandle(AtlasProdTag)& operator=(const ooRef(AtlasProdTag)& id);
    ooHandle(AtlasProdTag)& operator=(const ooHandle(AtlasProdTag)& objH);
    ooHandle(AtlasProdTag)& operator=(const ooShortRef(AtlasProdTag)& shortId);
    ooHandle(AtlasProdTag)& operator=(ooConstCPtr(AtlasProdTag) pObject);
    ooStatus lookupObj(const ooHandle(ooObj)& scopeH,
		       const ooKey& key,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const ooKey& key,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const ooHandle(ooObj)& scopeH,
		       const char* name,
		       ooMode openMode = oocRead);
    ooStatus lookupObj(const char* name,
		       ooMode openMode = oocRead);
    ooHandle(AtlasProdTag)& copy(const ooHandle(ooObj)& nearH,
			ooHandle(AtlasProdTag)& newObjH) const;
    ooRef(AtlasProdTag)& copy(const ooHandle(ooObj)& nearH,
		     ooRef(AtlasProdTag)& newObjH) const;
    ooHandle(AtlasProdTag) copy(const ooHandle(ooObj)& nearH) const;
    ooCPtr(AtlasProdTag) pin(ooMode openMode = oocRead) const;
    ooCPtr(AtlasProdTag) operator->() const;
    ooCRef(AtlasProdTag) operator*() const;
    operator ooCPtr(AtlasProdTag)() const;
    /* Use operator ooCPtr(AtlasProdTag)() instead of vm. */
    /* OBSOLETE */ ooCPtr(AtlasProdTag) vm() const;
    // ODMG methods:
    ooHandleStructor(AtlasProdTag)(const d_Ref_Any &from);
    operator d_Ref_Any() const;
    AtlasProdTag *ptr() const;
};

class ooItr(AtlasProdTag) : public ooHandle(AtlasProdTag) {
  public:
    ooItrStructor(AtlasProdTag)();
    ~ooItrStructor(AtlasProdTag)();
    ooStatus scan(const ooHandle(ooObj)& objH, ooMode mode = oocNoOpen);
    ooStatus scan(const ooHandle(ooObj)& objH, const char* predicate);
    ooStatus scan(const ooHandle(ooObj)& objH,
		  ooMode mode,
		  const ooAccessMode access,
		  const char* predicate);
    ooStatus scan(const ooHandle(ooObj)& objH,
		  const ooLookupKey& lookupKey,
		  ooMode mode = oocNoOpen);
    ooTypeNumber typeN() const;
    ooStatus	 end();
    ooBoolean	 next();
    ooIterator&	 get_itr();
  private:
    ooIterator	 _itr;
    ooItrStructor(AtlasProdTag)(ooItr(AtlasProdTag)&)
      {}
    void operator=(ooItr(AtlasProdTag)&)
      {}
};


/* methods on ooDeref(AtlasProdTag) */
inline
ooDeref(AtlasProdTag)::ooDerefStructor(AtlasProdTag)(ooDeref(AtlasProdTag)& deref)
{
  set_vm(deref.vm());
  pin();
}
inline
ooDeref(AtlasProdTag)::ooDerefStructor(AtlasProdTag)(ooCPtr(ooObj) pObject)
{
  set_vm(pObject);
}
inline
ooDeref(AtlasProdTag)::~ooDerefStructor(AtlasProdTag)()
{
  unpin();
}
inline
ooCPtr(AtlasProdTag)
ooDeref(AtlasProdTag)::operator->() const
{
  return  (ooCPtr(AtlasProdTag))vm();
}


/* methods on ooRef(AtlasProdTag) */
inline
#ifdef OO_BUGGY_TEMPLATES
ooRef(AtlasProdTag)::ooRefStructor(AtlasProdTag)(const ooHandle_superclass<AtlasProdTag > &objH)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooRef(AtlasProdTag)::ooRefStructor(AtlasProdTag)(const ooHandle(AtlasProdTag)& objH)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  opiCtIdByHandle(*this, objH);
}
inline
ooRef(AtlasProdTag)::ooRefStructor(AtlasProdTag)(ooConstCPtr(AtlasProdTag) pObject)
{
  opiCtIdByPtr(*this, pObject);
}
inline
ooRef(AtlasProdTag)&
ooRef(AtlasProdTag)::operator=(const ooRef(AtlasProdTag)& id)
{
  ooId::operator=(id);
  return *this;
}
inline
ooRef(AtlasProdTag)&
#ifdef OO_BUGGY_TEMPLATES
ooRef(AtlasProdTag)::operator=(const ooShortRef_superclass<AtlasProdTag > &shortId)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooRef(AtlasProdTag)::operator=(const ooShortRef(AtlasProdTag)& shortId)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  ooId::operator=(shortId);
  return *this;
}
inline
ooRef(AtlasProdTag)&
#ifdef OO_BUGGY_TEMPLATES
ooRef(AtlasProdTag)::operator=(const ooHandle_superclass<AtlasProdTag > &objH)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooRef(AtlasProdTag)::operator=(const ooHandle(AtlasProdTag)& objH)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  opiCtIdByHandle(*this, objH);
  return *this;
}
inline
ooRef(AtlasProdTag)&
ooRef(AtlasProdTag)::operator=(ooConstCPtr(AtlasProdTag) pObject)
{
  opiAsIdByPtr(*this, pObject);
  return *this;
}
inline
ooStatus
ooRef(AtlasProdTag)::lookupObj(const ooKey& key, ooMode openMode)
{
  return lookupObj(oovTopDB, key, openMode);
}
inline
ooStatus
ooRef(AtlasProdTag)::lookupObj(const char* name, ooMode openMode)
{
  return lookupObj(oovTopDB, name, openMode);
}
inline
ooCPtr(AtlasProdTag)
ooRef(AtlasProdTag)::vm(ooMode openMode) const
{
  ooId tempId(*this);
  return (ooCPtr(AtlasProdTag)) opiOidVM(&tempId, openMode);
}
inline
ooCPtr(AtlasProdTag)
ooRef(AtlasProdTag)::pin(ooMode openMode) const
{
  ooId tempId(*this);
  return (ooCPtr(AtlasProdTag)) opiOidVM(&tempId, openMode);
}
#ifndef OO_BUGGY_TEMPLATES
inline
ooHandle(AtlasProdTag)&
ooRef(AtlasProdTag)::copy(const ooHandle(ooObj)& nearH,
		 ooHandle(AtlasProdTag)& newObjH) const
{
  ooHandle(AtlasProdTag) thisH(*this);
      opiCopyObj(&thisH, nearH, newObjH);
  return newObjH;
}
inline
ooRef(AtlasProdTag)&
ooRef(AtlasProdTag)::copy(const ooHandle(ooObj)& nearH,
		 ooRef(AtlasProdTag)& newObjId) const
{
  ooHandle(AtlasProdTag) thisH(*this);
  ooHandle(AtlasProdTag) newObjH;
  opiCopyObj(&thisH, nearH, newObjH);
  newObjId = newObjH;
  return newObjId;
}
inline
ooHandle(AtlasProdTag)
ooRef(AtlasProdTag)::copy(const ooHandle(ooObj)& nearH) const
{
  ooHandle(AtlasProdTag) thisH(*this);
  ooHandle(AtlasProdTag) newObjH;
  opiCopyObj(&thisH, nearH, newObjH);
  return newObjH;
}
#endif  // !defined(OO_BUGGY_TEMPLATES)
#if !defined(__DECCXX) || !defined(OO_VMS)
inline
ooDeref(AtlasProdTag)
ooRef(AtlasProdTag)::operator->() const
{
  ooId tempId(*this);
  ooDeref(AtlasProdTag) deref(opiOidVM(&tempId, oocRead));
  return deref;
}
#endif


/* methods on ooShortRef(AtlasProdTag) */
inline
ooShortRef(AtlasProdTag)::ooShortRefStructor(AtlasProdTag)()
{
}
inline
ooShortRef(AtlasProdTag)::ooShortRefStructor(AtlasProdTag)(const ooShortRef(AtlasProdTag)& shortId)
{
  ooShortId::operator=(shortId);
}
inline
ooShortRef(AtlasProdTag)::ooShortRefStructor(AtlasProdTag)(const ooRef(AtlasProdTag)& id)
{
  ooShortId::operator=(id);
}
inline
#ifdef OO_BUGGY_TEMPLATES
ooShortRef(AtlasProdTag)::ooShortRefStructor(AtlasProdTag)(const ooHandle_superclass<AtlasProdTag > &objH)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooShortRef(AtlasProdTag)::ooShortRefStructor(AtlasProdTag)(const ooHandle(AtlasProdTag)& objH)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  opiCtShortIdByHandle(*this, objH);
}
inline
ooShortRef(AtlasProdTag)::ooShortRefStructor(AtlasProdTag)(ooConstCPtr(AtlasProdTag) pObject)
{
  opiCtShortIdByPtr(*this, pObject);
}
inline
ooShortRef(AtlasProdTag)&
ooShortRef(AtlasProdTag)::operator=(const ooShortRef(AtlasProdTag)& shortId)
{
  ooShortId::operator=(shortId);
  return *this;
}
inline
ooShortRef(AtlasProdTag)&
ooShortRef(AtlasProdTag)::operator=(const ooRef(AtlasProdTag)& id)
{
  ooShortId::operator=(id);
  return *this;
}
inline
ooShortRef(AtlasProdTag)&
#ifdef OO_BUGGY_TEMPLATES
ooShortRef(AtlasProdTag)::operator=(const ooHandle_superclass<AtlasProdTag > &objH)
#else  // !defined(OO_BUGGY_TEMPLATES)
ooShortRef(AtlasProdTag)::operator=(const ooHandle(AtlasProdTag)& objH)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
  opiCtShortIdByHandle(*this, objH);
  return *this;
}
inline
ooShortRef(AtlasProdTag)&
ooShortRef(AtlasProdTag)::operator=(ooConstCPtr(AtlasProdTag) pObject)
{
  opiAsShortIdByPtr(*this, pObject);
  return *this;
}


/* methods on ooHandle(AtlasProdTag) */
inline
ooHandle(AtlasProdTag)::ooHandleStructor(AtlasProdTag)()
{
}
inline
ooHandle(AtlasProdTag)::ooHandleStructor(AtlasProdTag)(const ooHandle(AtlasProdTag)& objH)
{
  opiCtHandleByHandle(*this, objH);
}
inline
ooHandle(AtlasProdTag)::ooHandleStructor(AtlasProdTag)(const ooRef(AtlasProdTag)& id) :
#ifdef OO_BUGGY_TEMPLATES
    ooHandle_superclass<AtlasProdTag >(id)
#else  // !defined(OO_BUGGY_TEMPLATES)
    ooHandle(HepEventTag)(id)
#endif  // !defined(OO_BUGGY_TEMPLATES)
{
}
inline
ooHandle(AtlasProdTag)::ooHandleStructor(AtlasProdTag)(ooConstCPtr(AtlasProdTag) pObject)
{
  opiCtHandleByPtr(*this, pObject);
}
inline
ooHandle(AtlasProdTag)&
ooHandle(AtlasProdTag)::operator=(const ooHandle(AtlasProdTag)& objH)
{
  opiAsHandleByHandle(*this, objH);
return *this;
}
inline
ooHandle(AtlasProdTag)&
ooHandle(AtlasProdTag)::operator=(const ooRef(AtlasProdTag)& id)
{
  opiAsHandleById(*this, id);
  return *this;
}
inline
ooHandle(AtlasProdTag)&
ooHandle(AtlasProdTag)::operator=(const ooShortRef(AtlasProdTag)& shortId)
{
  opiAsHandleByShortId(*this, shortId);
  return *this;
}
inline
ooHandle(AtlasProdTag)&
ooHandle(AtlasProdTag)::operator=(ooConstCPtr(AtlasProdTag) pObject)
{
  (pObject) ? opiAsHandleByPtr(*this, pObject) : nullify();
  return *this;
}
inline
ooStatus
ooHandle(AtlasProdTag)::lookupObj(const ooKey& key, ooMode openMode)
{
  return lookupObj(oovTopDB, key, openMode);
}
inline
ooStatus
ooHandle(AtlasProdTag)::lookupObj(const char* name, ooMode openMode)
{
  return lookupObj(oovTopDB, name, openMode);
}
inline
ooCPtr(AtlasProdTag)
ooHandle(AtlasProdTag)::vm() const
{
  return (ooCPtr(AtlasProdTag))get_vm();
}
inline
ooCRef(AtlasProdTag)
ooHandle(AtlasProdTag)::operator*() const
{
  return *vm();
}
inline
ooCPtr(AtlasProdTag)
ooHandle(AtlasProdTag)::pin(ooMode openMode) const
{
  opiOpenObj(this, openMode);
  opiPinDeref(get_fast_vm());
  return (ooCPtr(AtlasProdTag))get_fast_vm();
}
inline
ooCPtr(AtlasProdTag)
ooHandle(AtlasProdTag)::operator->() const
{
  return (ooCPtr(AtlasProdTag))get_vm();
}
inline
ooHandle(AtlasProdTag)::operator ooCPtr(AtlasProdTag)() const
{
  return (ooCPtr(AtlasProdTag))get_vm();
}
inline
ooRef(AtlasProdTag)&
ooHandle(AtlasProdTag)::copy(const ooHandle(ooObj)& nearH, ooRef(AtlasProdTag)& newObjId) const
{
  ooHandle(AtlasProdTag) newObjH;
  opiCopyObj(this, nearH, newObjH);
  newObjId = newObjH;
  return newObjId;
}


/* methods on ooItr(AtlasProdTag) */
inline
ooStatus
ooItr(AtlasProdTag)::scan(const ooHandle(ooObj)& objH, ooMode mode)
{
  return opiInitScanItr(*this, objH, mode);
}
inline
ooStatus
ooItr(AtlasProdTag)::scan(const ooHandle(ooObj)& objH,
		 const ooLookupKey& lookupKey,
		 ooMode mode)
{
  return opiInitScanIndexItr(*this, objH, lookupKey, mode);
}
inline
ooTypeNumber
ooItr(AtlasProdTag)::typeN() const
{
  return opiGetItrTypeN(this);
}
inline
ooStatus
ooItr(AtlasProdTag)::end()
{
  return opiCloseItr(*this);
}
inline
ooBoolean
ooItr(AtlasProdTag)::next()
{
  return _itr.next(self());
}
inline
ooIterator&
ooItr(AtlasProdTag)::get_itr()
{
  return _itr;
}
inline
ooStatus
ooItr(AtlasProdTag)::scan(const ooHandle(ooObj)& objH,
		const char* predicate)
{
  return opiInitScanVPredItr(*this, objH, predicate, oocPublic, oocNoOpen);
}
inline
ooStatus
ooItr(AtlasProdTag)::scan(const ooHandle(ooObj)& objH,
		 ooMode mode,
		 const ooAccessMode access,
		 const char* predicate)
{
  return opiInitScanVPredItr(*this, objH, predicate, access, mode);
}

/* ODMG methods */
inline
ooRef(AtlasProdTag)::operator d_Ref_Any() const
{
  return (*((d_Ref_Any *) (this)));
}
inline
AtlasProdTag *
ooRef(AtlasProdTag)::ptr() const
{
  return this->pin();
}
inline
ooHandle(AtlasProdTag)::operator d_Ref_Any() const
{
  ooRef(AtlasProdTag) result = *this;
  return (*((const d_Ref_Any *) (&result)));
}
inline
AtlasProdTag *
ooHandle(AtlasProdTag)::ptr() const
{
  return this->operator->();
}
#if defined(_MSC_VER) && !defined(OO_DDL_TRANSLATION)
#pragma pack(pop)
#endif

#endif /* _ATLAS_PROD_REF_H */

