#ifndef AtlasProd_H
#define AtlasProd_H

#include <TObject.h>
#include <TClonesArray.h>


class AtlasProdParticle : public TObject {
public :
  Short_t istat;
  Short_t ipdg;
  Short_t imo1;
  Short_t imo2;
  Short_t idau;
  Float_t px;
  Float_t py;
  Float_t pz;
  Float_t mass;
  Float_t tof;
  Float_t vx;
  Float_t vy;
  Float_t vz;

  AtlasProdParticle() { }
  virtual ~AtlasProdParticle() { }

  ClassDef(AtlasProdParticle,1) //AtlasProdParticle
};

class AtlasProdCalo {
public :
  UShort_t  N_total;
  Float_t   E_total;

  AtlasProdCalo() { }
  virtual ~AtlasProdCalo() { }

  ClassDef(AtlasProdCalo,1) //AtlasProdCalo
};

class AtlasProdEvent : public TObject {
public :
  Int_t idrun ;
  Int_t idevnt ;
  Int_t itrflag ;
  Int_t ISUB ;
  Int_t  Nhard ;
  Short_t Npart ;
  Float_t vvx ;
  Float_t vvy ;
  Float_t vvz ;
  Float_t  time;
  UShort_t Npgenz; 
  UShort_t Ngtrack; 
  UShort_t Ngvertx; 
  UShort_t Ngstmax; 
  UShort_t Nsetdet; 
  Int_t   Ngtmult;
  Int_t   Nwords;
  Int_t   Nwfree;
  Int_t   NPIXHPBCR;
  Int_t   LPIXHPBCR;
  Int_t   NPIXHPECR;
  Int_t   LPIXHPECR;
  Int_t   NSCTHSCTB;
  Int_t   LSCTHSCTB;
  Int_t   NZSCHZSEN;
  Int_t   LZSCHZSEN;
  Int_t   NXTRHXGAS;
  Int_t   LXTRHXGAS;
  Int_t   NCOIHCOEA;
  Int_t   LCOIHCOEA;
  Int_t   NCRYHCBEA;
  Int_t   LCRYHCBEA;
  Int_t   NCRYHCEEA;
  Int_t   LCRYHCEEA;
  Int_t   NCRYHCEPS;
  Int_t   LCRYHCEPS;
  Int_t   NCRYHCRAC;
  Int_t   LCRYHCRAC;
  Int_t   NCRYHCREC;
  Int_t   LCRYHCREC;
  Int_t   NACCHSTAC;
  Int_t   LACCHSTAC;
  Int_t   NCOPHCPCE;
  Int_t   LCOPHCPCE;
  Int_t   NENDHENDC;
  Int_t   LENDHENDC;
  Int_t   NTILHTBSA;
  Int_t   LTILHTBSA;
  Int_t   NHENHHLAR;
  Int_t   LHENHHLAR;
  Int_t   NFWDHFWAI;
  Int_t   LFWDHFWAI;
  Int_t   NPIXDPBCR;
  Int_t   LPIXDPBCR;
  Int_t   NPIXDPECR;
  Int_t   LPIXDPECR;
  Int_t   NSCTDSCTB;
  Int_t   LSCTDSCTB;
  Int_t   NZSCDZSEN;
  Int_t   LZSCDZSEN;
  Int_t   NXTRDXGAS;
  Int_t   LXTRDXGAS;
  Int_t   NCRYDCBEA;
  Int_t   LCRYDCBEA;
  Int_t   NCRYDCEEA;
  Int_t   LCRYDCEEA;
  Int_t   NCRYDCRAC;
  Int_t   LCRYDCRAC;
  Int_t   NCRYDCREC;
  Int_t   LCRYDCREC;
  Int_t   NCRYDCEPS;
  Int_t   LCRYDCEPS;
  Int_t   NACCDSTAC;
  Int_t   LACCDSTAC;
  Int_t   NCOPDCOPH;
  Int_t   LCOPDCOPH;
  Int_t   NENDDENDC;
  Int_t   LENDDENDC;
  Int_t   NTILDTBMA;
  Int_t   LTILDTBMA;
  Int_t   NHENDHENN;
  Int_t   LHENDHENN;
  Int_t   NFWDDFWSI;
  Int_t   LFWDDFWSI;
  Int_t   Nsum;
  UShort_t  N_total[3];
  Float_t   E_total[3];
//  AtlasProdCalo calos[3];
  TClonesArray *particles;

  AtlasProdEvent();
  virtual ~AtlasProdEvent() { }

  AtlasProdParticle *GetParticle(Int_t idx) const
    { return (AtlasProdParticle*)particles->UncheckedAt(idx); }

  ClassDef(AtlasProdEvent,1) //AtlasProdEvent
};

class AtlasProdTag : public TObject {
public:
  Int_t idrun ;
  Int_t idevnt ;
  Int_t itrflag ;
  Int_t ISUB ;
  Int_t  Nhard ;
  Short_t Npart ;
  Float_t vvx ;
  Float_t vvy ;
  Float_t vvz ;

  AtlasProdTag () { }
  virtual ~AtlasProdTag() { }

  ClassDef(AtlasProdTag,1) //AtlasProdTag
};

#endif
